################################################################################
# THIS FUNCTION ESTIMATES F(U,U) JOINT DENSITY OF U_T AND U_{T+1}
################################################################################
source("_est_fuu.r");

est_fvv <- function(t,fuu,phi_v_list,slist,ulist,vlist,min_age,nonnegative=FALSE,graph=FALSE){

extract = extract_data(t,t+1,TRUE);

uu = array(ulist,dim=c(length(ulist),length(ulist)));
#fuu <- est_fuu(t,phi_u_list,phi_eta_list,slist,ulist,min_age,FALSE);

phi_vv_list = array(0,dim=c(length(slist),length(slist)));
for(iter in 1:length(slist)){
 for(jter in 1:length(slist)){
  s1 = slist[iter];
  s2 = slist[jter];
  num = mean( exp(1i*s1*extract[,1] + 1i*s2*extract[,2]) );
  den = sum( exp(1i*s1*uu + 1i*s2*t(uu)) * fuu * (ulist[2]-ulist[1])^2 );
  phi_vv_list[iter,jter] = num / den;
 }
}

middle_s_idx = (length(slist)+1)/2;
temp_slist_interval = slist[2:length(slist)] - slist[1:(length(slist)-1)];
slist_interval = c(temp_slist_interval[1:(middle_s_idx-1)], temp_slist_interval[middle_s_idx], temp_slist_interval[middle_s_idx:length(temp_slist_interval)]);
s1mat = array(slist,dim=c(length(slist),length(slist)));
s2mat = t(array(slist,dim=c(length(slist),length(slist))));


hlist = 1:25/100;
min_h = 0;
min_ise = 999999;
var_v = get_variance(phi_v_list[t-min_age+1,],slist)
for(hter in 1:length(hlist)){
 h = hlist[hter];
 fv = array(0,length(vlist));
 for(iter in 1:length(vlist)){
  v1 = vlist[iter];
  v2 = 0;
  fv[iter] = sum( exp(-1i*s1mat*v1 -1i*s2mat*v2) * phi_vv_list * ker( h*s1mat ) * ker( h*s2mat ) * (slist_interval%*%t(slist_interval)) ) * 1/2^2/3.14159^2;
  fv[iter] = Re(fv[iter]);
 }
 ise = sum( ( Re(fv) - dnorm(vlist,0,var_v^.5) )^2 );
 if( ise < min_ise ){
  min_ise = ise;
  min_h = h;
 }
}

h = min_h
fvv = array(0,dim=c(length(vlist),length(vlist)));
for(iter in 1:length(vlist)){
 for(jter in 1:length(vlist)){
  v1 = vlist[iter];
  v2 = vlist[jter];
  fvv[iter,jter] = sum( exp(-1i*s1mat*v1 -1i*s2mat*v2) * phi_vv_list * ker( h*s1mat ) * ker( h*s2mat ) * (slist_interval%*%t(slist_interval)) ) * 1/2^2/3.14159^2;
  fvv[iter,jter] = Re(fvv[iter,jter]);
 }
}

if(nonnegative){
 fvv = (Re(fvv) > 0) * fvv + (Re(fvv) <= 0) * 0;
 fvv = fvv / sum( Re(fvv)*(vlist[2]-vlist[1])^2 );
}

if(graph){
 contour(vlist,vlist,Re(fvv),xlab=expression(V[t]),ylab=expression(V[t+1]));
 abline(coef=c(0,1),lty=3);
}

return( Re(fvv) );
}
