################################################################################
# DISPLAY LAMBDA ###############################################################
options("scipen"=100, "digits"=3)
lambda_list;
plot(age_list,lambda_list,type="l",lty=1,ylim=c(-2.0,0),xlab=expression(paste("Age ", t)),ylab=expression(paste("MA Coefficient  ",lambda[t])));

################################################################################
# DISPLAY EPSILON ACROSS MULTIPLE AGES #########################################
agelist = c(30,40,49);
undersmooth = 0.0;
epsilonlist = -50:50/50 * 1.00;
xlimmin = -0.45;
xlimmax = 0.45;
ylimmin = -0.0;
ylimmax = 3.0;
fepsilonlist = epsilonlist * 0;
t = agelist[1];
h = choose_h_normal_reference(epsilonlist,phi_epsilon_list[t-min_age+1,],slist_coarse,NULL);
h = h * (1 - undersmooth);
for( iter in 1:length(epsilonlist) ){
 fepsilonlist[iter] = fourier(epsilonlist[iter],phi_epsilon_list[t-min_age+1,],slist_coarse,h,TRUE);
}
fepsilonlist = fepsilonlist / sum(fepsilonlist *(epsilonlist[2]-epsilonlist[1]));
plot(epsilonlist,fepsilonlist,type="l",xlim=c(xlimmin,xlimmax),ylim=c(ylimmin,ylimmax),xlab=expression(epsilon[t]),ylab="Density");
for( jter in 2:length(agelist) ){
 fepsilonlist = epsilonlist * 0;
 t = agelist[jter];
 h = choose_h_normal_reference(epsilonlist,phi_epsilon_list[t-min_age+1,],slist_coarse,NULL);
 h = h * (1 - undersmooth); 
 for( iter in 1:length(epsilonlist) ){
  fepsilonlist[iter] = fourier(epsilonlist[iter],phi_epsilon_list[t-min_age+1,],slist_coarse,h,TRUE);
 }
 fepsilonlist = fepsilonlist / sum(fepsilonlist*(epsilonlist[2]-epsilonlist[1]));
 par(new=TRUE);
 plot(epsilonlist,fepsilonlist,type="l",lty=jter,xlim=c(xlimmin,xlimmax),ylim=c(ylimmin,ylimmax),xlab="",ylab="");
}
agelist = c(30,40,50);
legend(xlimmin,ylimmax,paste("t =",agelist),lty=order(agelist));

################################################################################
# DISPLAY EPSILON AND LAG LAMBDA EPSILON #######################################
t = 30;
undersmooth = 0.0;
epsilonlist = -50:50/50 * 1.00;
xlimmin = -0.45;
xlimmax = 0.45;
ylimmin = -0.0;
ylimmax = 3.0;
fepsilonlist = epsilonlist * 0;
flambdaepsilonlist = epsilonlist * 0;
fsumlist = epsilonlist * 0;
h = choose_h_normal_reference(epsilonlist,phi_epsilon_list[t-min_age+1,],slist_coarse,NULL);
h = h * (1 - undersmooth);
for( iter in 1:length(epsilonlist) ){
 fepsilonlist[iter] = fourier(epsilonlist[iter],phi_epsilon_list[t-min_age+1,],slist_coarse,h,TRUE);
}
fepsilonlist = fepsilonlist / sum(fepsilonlist *(epsilonlist[2]-epsilonlist[1]));
plot(epsilonlist,fepsilonlist,type="l",xlim=c(xlimmin,xlimmax),ylim=c(ylimmin,ylimmax),xlab=expression(epsilon[t]),ylab="Density");
for( iter in 1:length(epsilonlist) ){
 flambdaepsilonlist[iter] = fourier(epsilonlist[iter],phi_lambdaepsilon_list[t-min_age+1-1,],slist_coarse,h,TRUE);
}
flambdaepsilonlist = flambdaepsilonlist / sum(flambdaepsilonlist *(epsilonlist[2]-epsilonlist[1]));
par(new=TRUE);
plot(epsilonlist,flambdaepsilonlist,type="l",lty=2,xlim=c(xlimmin,xlimmax),ylim=c(ylimmin,ylimmax),xlab="",ylab="");
for( iter in 1:length(epsilonlist) ){
 for( jter in 1:length(epsilonlist) ){
  iepsilon = epsilonlist[iter];
  jepsilon = epsilonlist[jter];
  diffidx = order( abs( epsilonlist - ( iepsilon - jepsilon ) ) )[1];
  fsumlist[iter] = fsumlist[iter] + fepsilonlist[jter] * flambdaepsilonlist[diffidx] * (epsilonlist[2]-epsilonlist[1]);
 }
}
fsumlist = fsumlist / sum(fsumlist *(epsilonlist[2]-epsilonlist[1]));
par(new=TRUE);
plot(epsilonlist,fsumlist,type="l",lty=3,xlim=c(xlimmin,xlimmax),ylim=c(ylimmin,ylimmax),xlab="",ylab="");
legend(xlimmin,ylimmax,c(expression(epsilon[t]),expression(paste(lambda[t], epsilon[t-1])),expression(paste(epsilon[t], "+",lambda[t], epsilon[t-1]))),lty=c(1,2,3));

################################################################################
# DISPLAY MA SUM ACROSS MULTIPLE AGES ##########################################
agelist = c(30,40,49);
undersmooth = 0.0;
epsilonlist = -50:50/50 * 1.00;
xlimmin = -0.45;
xlimmax = 0.45;
ylimmin = -0.0;
ylimmax = 2.5;
flambdaepsilonlist = epsilonlist * 0;
t = agelist[1];
h = choose_h_normal_reference(epsilonlist,phi_epsilon_list[t-min_age+1,],slist_coarse,NULL);
h = h * (1 - undersmooth);
for( iter in 1:length(epsilonlist) ){
 fepsilonlist[iter] = fourier(epsilonlist[iter],phi_epsilon_list[t-min_age+1,],slist_coarse,h,TRUE);
}
fepsilonlist = fepsilonlist / sum(fepsilonlist *(epsilonlist[2]-epsilonlist[1]));
for( iter in 1:length(epsilonlist) ){
 flambdaepsilonlist[iter] = fourier(epsilonlist[iter],phi_lambdaepsilon_list[t-min_age+1-1,],slist_coarse,h,TRUE);
}
flambdaepsilonlist = flambdaepsilonlist / sum(flambdaepsilonlist *(epsilonlist[2]-epsilonlist[1]));
for( iter in 1:length(epsilonlist) ){
 for( jter in 1:length(epsilonlist) ){
  iepsilon = epsilonlist[iter];
  jepsilon = epsilonlist[jter];
  diffidx = order( abs( epsilonlist - ( iepsilon - jepsilon ) ) )[1];
  fsumlist[iter] = fsumlist[iter] + fepsilonlist[jter] * flambdaepsilonlist[diffidx] * (epsilonlist[2]-epsilonlist[1]);
 }
}
fsumlist = fsumlist / sum(fsumlist *(epsilonlist[2]-epsilonlist[1]));
plot(epsilonlist,fsumlist,type="l",xlim=c(xlimmin,xlimmax),ylim=c(ylimmin,ylimmax),xlab=expression(paste(epsilon[t], "+",lambda[t], epsilon[t-1])),ylab="Density");
for( idx in 2:length(agelist) ){
 flambdaepsilonlist = epsilonlist * 0;
 t = agelist[idx];
 h = choose_h_normal_reference(epsilonlist,phi_epsilon_list[t-min_age+1,],slist_coarse,NULL);
 h = h * (1 - undersmooth);
 for( iter in 1:length(epsilonlist) ){
  fepsilonlist[iter] = fourier(epsilonlist[iter],phi_epsilon_list[t-min_age+1,],slist_coarse,h,TRUE);
 }
 fepsilonlist = fepsilonlist / sum(fepsilonlist *(epsilonlist[2]-epsilonlist[1]));
 for( iter in 1:length(epsilonlist) ){
  flambdaepsilonlist[iter] = fourier(epsilonlist[iter],phi_lambdaepsilon_list[t-min_age+1-1,],slist_coarse,h,TRUE);
 }
 flambdaepsilonlist = flambdaepsilonlist / sum(flambdaepsilonlist *(epsilonlist[2]-epsilonlist[1]));
 for( iter in 1:length(epsilonlist) ){
  for( jter in 1:length(epsilonlist) ){
   iepsilon = epsilonlist[iter];
   jepsilon = epsilonlist[jter];
   diffidx = order( abs( epsilonlist - ( iepsilon - jepsilon ) ) )[1];
   fsumlist[iter] = fsumlist[iter] + fepsilonlist[jter] * flambdaepsilonlist[diffidx] * (epsilonlist[2]-epsilonlist[1]);
  }
 }
 fsumlist = fsumlist / sum(fsumlist *(epsilonlist[2]-epsilonlist[1]));
 par(new=TRUE);
 plot(epsilonlist,fsumlist,type="l",lty=idx,xlim=c(xlimmin,xlimmax),ylim=c(ylimmin,ylimmax),xlab="",ylab="");
}
agelist = c(30,40,50);
legend(xlimmin,ylimmax,paste("t =",agelist),lty=order(agelist));

