################################################################################
# THIS MODULE PRODUCES MOMENTS AND INDICES BY INTEGRATION OF ESTIMATED DENS ####
t = 30;

#minY = 0;
#maxY = 0;
#for(tdx in min_age:(max_age-1)){
# current_Yt = extract_data(tdx,tdx+1,DEMEAN=TRUE);
# if( minY > min(current_Yt[,1]) ){
#  minY = min(current_Yt[,1]);
# }
# if(maxY < max(current_Yt[,1])){
#  maxY = max(current_Yt[,1]);
# }
#}
# THE minY AND maxY OBTAINED IN THE ABOVE COMMENTED LINES OF THE CODE ##########
minY = -10.90416;
maxY = 3.083533;
limit_int = max( -1*minY, maxY );

################################################################################
# COMPUTE MOMENT AND INDICES FOR U USING INTEGRATION OF ESTIMATED DENSITIES ####
undersmooth = 0.0;
ulist = -50:50/50 * limit_int;
ulist = ulist[(1+sum(ulist < minY)):length(ulist)];
ulist = ulist[1:(length(ulist)-sum(ulist > maxY))];
ulist_interval = ulist[2] - ulist[1]
fulist = ulist * 0;
h = choose_h_normal_reference(ulist,phi_u_list[t-min_age+1,],slist,var_u_list[t-min_age+1]);
h = h * (1 - undersmooth);
for( iter in 1:length(ulist) ){
 fulist[iter] = fourier(ulist[iter],phi_u_list[t-min_age+1,],slist,h,TRUE);
}
fulist = fulist / sum(fulist*(ulist[2]-ulist[1]));

int_mean_u = sum( ulist * fulist * ulist_interval );
int_sd_u = sum( (ulist - int_mean_u)^2 * fulist * ulist_interval )^.5;
int_skewness_u = sum( (ulist - int_mean_u)^3 * fulist * ulist_interval ) / int_sd_u^3;
int_kurtosis_u = sum( (ulist - int_mean_u)^4 * fulist * ulist_interval ) / int_sd_u^4;

################################################################################
# COMPUTE MOMENT AND INDICES FOR V USING INTEGRATION OF ESTIMATED DENSITIES ####
undersmooth = 0.0;
vlist = -50:50/50 * limit_int;
vlist = vlist[(1+sum(vlist < minY)):length(vlist)];
vlist = vlist[1:(length(vlist)-sum(vlist > maxY))];
vlist_interval = vlist[2] - vlist[1]
fvlist = vlist * 0;
h = choose_h_normal_reference(vlist,phi_v_list[t-min_age+1,],slist,var_v_list[t-min_age+1]);
h = h * (1 - undersmooth);
for( iter in 1:length(vlist) ){
 fvlist[iter] = fourier(vlist[iter],phi_v_list[t-min_age+1,],slist,h,TRUE);
}
fvlist = fvlist / sum(fvlist*(vlist[2]-vlist[1]));

int_mean_v = sum( vlist * fvlist * vlist_interval );
int_sd_v = sum( (vlist - int_mean_v)^2 * fvlist * vlist_interval )^.5;
int_skewness_v = sum( (vlist - int_mean_v)^3 * fvlist * vlist_interval ) / int_sd_v^3;
int_kurtosis_v = sum( (vlist - int_mean_v)^4 * fvlist * vlist_interval ) / int_sd_v^4;

################################################################################
# DISPLAY INDICES FOR U AND V ##################################################
int_mean_u
int_sd_u
int_skewness_u
int_kurtosis_u

int_mean_v
int_sd_v
int_skewness_v
int_kurtosis_v

