source("_extract_data.r");
source("_est_rho_alltogether_parametric.r");
source("_est_phi_v.r");
source("_est_phi_u.r");
source("_est_phi_eta.r");
source("_get_mean.r");
source("_get_variance.r");
source("_fourier.r");
source("_choose_h_normal_reference.r");
source("_compute_moment.r");
source("_est_fuu.r");
source("_est_fvv.r");
source("_est_fuuu.r");
source("_est_fvvv.r");
source("_get_varVrhoV.r");
source("_get_covVrhoV.r");
source("_est_lambda.r");
source("_est_phi_epsilon.r");
source("_est_phi_lambdaepsilon.r");
source("_get_bivariate_normal.r");
source("_get_bivariate_normal_conditional_expectation.r");
source("_get_var_list.r");
source("_stationary_get_var_list.r");
source("_stationary_est_rho_alltogether_parametric.r");
source("_stationary_est_phi_v.r");
source("_stationary_est_phi_u.r");
source("_stationary_est_phi_eta.r");
p = 1;
q = 1;
min_age = 25;
max_age = 55;

################################################################################
# ESTIMATE RHO
################################################################################
polynomial = 3;        ### Degree of Polynomial for Life-Cycle Specification of RHO
rho_list <- est_rho_alltogether_parametric(polynomial,min_age,max_age,p,q);

################################################################################
# ESTIMATE VARIANCES OF U AND V
################################################################################
var_list <- get_var_list(min_age,max_age,p,q,rho_list);
var_u_list = var_list[,1];
var_v_list = var_list[,2];
var_eta_list = var_list[,3];

################################################################################
# ESTIMATE PHI_V, PHI_U, AND PHI_ETA WITH VERY FINE RESOLUTION OF S
################################################################################
coarseness = 0.01;
max_exp = 100 / coarseness;
slist = c(-1*1.05^(-3.3*coarseness*((-1*max_exp):0)), 0, 1.05^(3.3*coarseness*(0:max_exp))) * 0.0001;
phi_v_list <- est_phi_v(min_age,max_age,p,q,slist,rho_list);
phi_u_list <- est_phi_u(min_age,max_age,slist,phi_v_list);
phi_eta_list <- est_phi_eta(min_age,max_age,slist,phi_u_list);

################################################################################
# ESTIMATE THE JOINT DENSITIES BY "estimation_joint_densities.r" TAKES LONG!!!
################################################################################
source("estimation_joint_densities.r");

################################################################################
# ESTIMATE LAMBDA FOR ARMA(1,1) MODEL
################################################################################
# ESTIMATE VAR OF V_{T+1} - RHO_{T+1} V_{T} LATER USED TO ESTIMATE LAMBDA ######
varVrhoVlist = array(0,length(age_list));
for(iter in 1:length(age_list)){
 t = age_list[iter];
 varVrhoVlist[iter] = get_varVrhoV(fvvlist[iter,,],vlist_coarse,rho_list[t-min_age+1]);
}
varVrhoVlist;

# ESTIMATE COV OF V_{T+1} - RHO_{T+1} V_{T} LATER USED TO ESTIMATE LAMBDA ######
covVrhoVlist = array(0,length(age_list));
for(iter in 1:length(age_list)){
 t = age_list[iter];
 covVrhoVlist[iter] = get_covVrhoV(fvvvlist[iter,,,],vlist_verycoarse,rho_list[t-min_age+1],rho_list[t-min_age+1+1]);
}
covVrhoVlist;

lambda_list = est_lambda(polynomial,age_list,varVrhoVlist,covVrhoVlist);
