################################################################################
# SUMMARY STAT 
################################################################################

### Read Data ##################################################################
#data <- read.csv("data_r.csv",header=FALSE);
data <- read.csv("data_noage_r.csv",header=FALSE);
data_id <- data[,1];    ### Individual ID
data_t <- data[,2];     ### Age
data_year <- data[,3];  ### Year
data_Y <- data[,4];     ### Residual
N = dim(data)[1];

min_t = min(data_t);
max_t = max(data_t);
T = max_t - min_t + 1;
min_year = min(data_year);
max_year = max(data_year);

################################################################################
# ASSIGN "NODATA" TO OUTLIERS
################################################################################
exist_mat = NULL;
exist_idx = 0;
prev_id = -999999;
for(iter in 1:N){
 if( data_id[iter] != prev_id ){
  exist_mat = rbind(exist_mat,array(FALSE,T));
  exist_idx = exist_idx + 1;
 }
 time_idx = data_t[iter] - min_t + 1;
 exist_mat[exist_idx,time_idx] = TRUE;

 prev_id = data_id[iter];
}

N_at_least_once = sum( rowSums(exist_mat*1) >= 1 );
N_at_least_10_periods = sum( rowSums(exist_mat*1) >= 10 );
N_at_least_20_periods = sum( rowSums(exist_mat*1) >= 20 );
N_at_least_30_periods = sum( rowSums(exist_mat*1) >= 30 );
N_all_time_periods = sum( rowSums(exist_mat*1) == T);

N_at_least_once;
N_at_least_10_periods;
N_at_least_20_periods;
N_at_least_30_periods;
N_all_time_periods;