################################################################################
# THIS FUNCTION CHOOSES BANDWIDTH BY MINIMIZING THE INTEGRATED SQUARED ERRORS
# WITH NORMAL DISTRIBUTION WITH THE SAME VARIANCE
################################################################################
source("_get_mean.r");
source("_get_variance.r");
source("_fourier.r");
hlist = 1:80/600;

choose_h_normal_reference <- function( xlist,phi,slist,var ){

mean = get_mean(phi,slist);
if( is.null(var) ){
 var = get_variance(phi,slist);
}
normlist = dnorm(xlist, mean, var^0.5);
min_ise = 999999;
min_h = NA;

for( h in hlist ){
 flist = xlist * 0;
 for( iter in 1:length(xlist) ){
  flist[iter] = fourier(xlist[iter],phi,slist,h,TRUE);
 }

 ise = sum( ( normlist - flist )^2 );
 if( !is.finite(ise) | is.na(ise) | is.nan(ise) ){
  ise = 999999;
 }
 if( ise < min_ise ){
  min_ise = ise;
  min_h = h;
 }
}

return( min_h );
}