################################################################################
# THIS FUNCTION ESTIMATES F(U,U) JOINT DENSITY OF U_T AND U_{T+1}
################################################################################

est_fuu <- function(t,phi_u_list,phi_eta_list,slist,ulist,min_age,var_u_list,nonnegative=FALSE,graph=FALSE){

fulist = ulist * 0;
h = choose_h_normal_reference(ulist,phi_u_list[t-min_age+1,],slist,var_u_list[t-min_age+1]);
for( iter in 1:length(ulist) ){
 fulist[iter] = fourier(ulist[iter],phi_u_list[t-min_age+1,],slist,h,TRUE);
}

etalist = (-1*length(ulist)):length(ulist) * (ulist[2]-ulist[1])
fetalist = etalist * 0;
h = choose_h_normal_reference(etalist,phi_eta_list[t-min_age+1+1,],slist,NULL);
for( iter in 1:length(etalist) ){
 fetalist[iter] = fourier(etalist[iter],phi_eta_list[t-min_age+1+1,],slist,h,TRUE);
}

fuu = array(0,dim=c(length(ulist),length(ulist)));
for(iter in 1:length(ulist)){
 for(jter in 1:length(ulist)){
  eta2 = ulist[jter] - ulist[iter];
  eta2idx = order(abs(etalist - eta2))[1];
  fuu[iter,jter] = fulist[iter] * fetalist[eta2idx];
 }
}

if(nonnegative){
 fuu = (Re(fuu) > 0) * fuu + (Re(fuu) <= 0) * fuu * 0;
 fuu = fuu / sum( fuu*(ulist[2]-ulist[1])^2 );
}

if(graph){
 contour(ulist,ulist,Re(fuu),xlab=expression(U[t]),ylab=expression(U[t+1]));
 abline(coef=c(0,1),lty=3);
}

return( Re(fuu) );
}
