################################################################################
# THIS FUNCTION ESTIMATES F(U,U,U) JOINT DENSITY OF U_T, U_{T+1} AND U_{T+2}
################################################################################

est_fuuu <- function(t,phi_u_list,phi_eta_list,slist,ulist,min_age,var_u_list,nonnegative=FALSE,graph=FALSE){

fulist = ulist * 0;
h = choose_h_normal_reference(ulist,phi_u_list[t-min_age+1,],slist,NULL);
for( iter in 1:length(ulist) ){
 fulist[iter] = fourier(ulist[iter],phi_u_list[t-min_age+1,],slist,h,TRUE);
}

etalist = (-1*length(ulist)):length(ulist) * (ulist[2]-ulist[1])
fetalist = etalist * 0;
h = choose_h_normal_reference(etalist,phi_eta_list[t-min_age+1+1,],slist,NULL);
for( iter in 1:length(etalist) ){
 fetalist[iter] = fourier(etalist[iter],phi_eta_list[t-min_age+1+1,],slist,h,TRUE);
}

eta3list = (-1*length(etalist)):length(etalist) * (ulist[2]-ulist[1])
feta3list = eta3list * 0;
h = choose_h_normal_reference(eta3list,phi_eta_list[t-min_age+1+2,],slist,NULL);
for( iter in 1:length(etalist) ){
 feta3list[iter] = fourier(eta3list[iter],phi_eta_list[t-min_age+1+2,],slist,h,TRUE);
}

fuuu = array(0,dim=c(length(ulist),length(ulist),length(ulist)));
for(iter in 1:length(ulist)){
 for(jter in 1:length(ulist)){
  for(kter in 1:length(ulist)){
   eta2 = ulist[jter] - ulist[iter];
   eta3 = ulist[kter] - ulist[jter];
   eta2idx = order(abs(etalist - eta2))[1];
   eta3idx = order(abs(eta3list - eta3))[1];
   fuuu[iter,jter,kter] = fulist[iter] * fetalist[eta2idx] * feta3list[eta3idx];
  }
 }
}

if(nonnegative){
 fuuu = (Re(fuuu) > 0) * Re(fuuu) + (Re(fuuu) <= 0) * Re(fuuu) * 0;
 fuuu = Re(fuuu) / sum( Re(fuuu)*(ulist[2]-ulist[1])^3 );
}

fuuu = Re(fuuu) / sum( Re(fuuu) * (ulist[2]-ulist[1])^3 );

if(graph){
 fuu = array(0,dim=c(length(ulist),length(ulist)));
 for(iter in 1:length(ulist)){
  for(kter in 1:length(ulist)){
   fuu[iter,kter] = sum(fuuu[iter,,kter] * (ulist[2]-ulist[1]));
  }
 }
 contour(ulist,ulist,Re(fuu),xlab=expression(U[t]),ylab=expression(U[t+2]));
 abline(coef=c(0,1),lty=3);
}

return( Re(fuuu) );
}
