################################################################################
# THIS FUNCTION ESTIMATES MA PARAMETER LAMBDA - RETURNS "lambda_list"
################################################################################

obj_est_lambda <- function(lambda_para_list,polynomial,age_list,varVrhoVlist,covVrhoVlist){
 lambda_list = 0 * age_list;
 for(iter in 1:polynomial){
  lambda_list = lambda_list + age_list^(iter-1) * lambda_para_list[iter];
 }

 dist = 0;
 for(iter in 2:(length(age_list)-2)){
  dist = lambda_list[iter+2] * varVrhoVlist[iter];
  dist = dist - lambda_list[iter+2] * lambda_list[iter+1] * covVrhoVlist[iter-1];
  dist = dist - covVrhoVlist[iter];
 }

 return( abs(dist^2) );
}

est_lambda <- function(polynomial,age_list,varVrhoVlist,covVrhoVlist){
 init_lambda_para_list = array(0,polynomial);
 est <- nlm(obj_est_lambda,init_lambda_para_list,polynomial,age_list,varVrhoVlist,covVrhoVlist);
 lambda_para_list = est$estimate;
 lambda_list = 0 * age_list;
 for(iter in 1:polynomial){
  lambda_list = lambda_list + age_list^(iter-1) * lambda_para_list[iter];
 }

 return( lambda_list );
}
