################################################################################
# THIS FUNCTION ESTIMATES AR PARAMETER(S) RHO ALL TOGETHER - RETURNS "rho_list"
################################################################################
source("_extract_data.r");

obj_est_rho_alltogether_parametric <- function(rho_para_list,K,extract_list,N_list,min_age,max_age,p,q){
rho_para_list = array(rho_para_list, dim=c(K,p));
rho_list = NULL;
for(iter in 1:p){
 curr_rho = 0;
 for(jter in 1:dim(rho_para_list)[1]){
  curr_rho = curr_rho + rho_para_list[jter,iter] * ( (min_age+p+q):(max_age+10) )^(jter-1)
 }
 rho_list = rbind(rho_list, curr_rho);
}

moments = NULL;
for( t in (min_age+p+q):(max_age-1)){
 extract = extract_list[t-(min_age+p+q)+1,1:N_list[t-(min_age+p+q)+1],];
 N = dim(extract)[1];
 T = dim(extract)[2] - 1;

 t-(min_age+p+q)+1
 rho = rho_list[,t-(min_age+p+q)+1];
 rho_plus = rho_list[,t-(min_age+p+q)+2];

 kappa = sum(rho) - 1;
 mu = extract[,T] - extract[,T-q-1];
 for(iter in 1:p){
  mu = mu - rho[iter] * (extract[,T-iter] - extract[,T-q-1]);
 }

 Lambda = NULL;
 Y_mat = NULL;
 for(iter in 1:p){
  Lambda = cbind(Lambda, kappa*(extract[,T+1-iter]-extract[,T-q-1]) + mu);
  Y_mat = cbind(Y_mat, extract[,T-q-iter]);
 }
 Lambda0 = kappa*(extract[,T+1]-extract[,T-q-1]) + mu;
 
 curr_moments = ( t(Y_mat)%*%Lambda ) %*% rho_plus - ( t(Y_mat)%*% Lambda0 );
 moments = rbind(moments, curr_moments / N);
}
obj = t(moments) %*% diag(array(1,length(moments))) %*% moments;

### Impose the sub-unit root assumption for rho_t for all t ###
penalty = (max(abs(colSums(rho_list))) > 1) * (max(abs(colSums(rho_list))) - 1)^2; #^4 * 1000000000;
obj = obj + penalty;

return( obj );
}


est_rho_alltogether_parametric <- function(polynomial,min_age,max_age,p,q){
K = polynomial + 1;
N_list = NULL;
for( t in (min_age+p+q):(max_age-1)){
 extract = extract_data(t-p-q,t+1,TRUE);
 N_list = rbind(N_list, dim(extract)[1]);
}
extract_list = array(0,dim=c(max_age-min_age-p-q,max(N_list),p+q+2));
for( t in (min_age+p+q):(max_age-1)){
 extract = extract_data(t-p-q,t+1,TRUE);
 extract_list[t-(min_age+p+q)+1,1:(dim(extract)[1]),] = extract;
}
init_rho_para_list = array(0,dim=c(K,p));
init_rho_para_list[1,]=0.0;
init_rho_para_list = c(init_rho_para_list);
est <- nlm(obj_est_rho_alltogether_parametric,init_rho_para_list,K,extract_list,N_list,min_age,max_age,p,q);
rho_para_list = est$estimate;
rho_para_list = array(rho_para_list, dim=c(K,p));
rho_list = NULL;
age = (min_age):max_age;
for(iter in 1:p){
 rho = 0;
 for(jter in 1:dim(rho_para_list)[1]){
  rho = rho + rho_para_list[jter,iter] * ( age )^(jter-1)
 }
 rho_list = rbind(rho_list, rho);
}
colnames(rho_list) <- age;

return ( t( rho_list ) );
}