################################################################################
# THIS FUNCTION ESTIMATES PHI_V - RETURNS "phi_v_list"
# ROWS = AGES, COLS = S
################################################################################

stationary_est_phi_v <- function(min_age,max_age,p,q,slist,rho_list){
phi_v_list = NULL;

################ BEGIN t = min_age ############################################
#for(t in min_age:(max_age-q-1)){
t = min_age;

curr_rho = t( rho_list[t-min_age+1,] );
extract = extract_data(t,t+q+1,TRUE);
N = dim(extract)[1];
middle_s_idx = (length(slist)+1)/2;
temp_slist_interval = slist[2:length(slist)] - slist[1:(length(slist)-1)];
slist_interval = c(temp_slist_interval[1:(middle_s_idx-1)], temp_slist_interval[middle_s_idx], temp_slist_interval[middle_s_idx:length(temp_slist_interval)]);

kappa = sum(curr_rho) - 1;
mu = extract[,1+q+1] - extract[,1];
for(iter in 1:p){
 mu = mu - curr_rho[iter]*(extract[,1+q+1-iter] - extract[,1]);
}

phi_v = array(0,length(slist));
for(iter in 1:((length(slist)-1)/2)){
 s = slist[middle_s_idx + iter];
 num = sum( 1i * mu * exp(1i * s * extract[,1]) );
 den = sum( kappa * exp(1i * s * extract[,1]) );
 phi_v[middle_s_idx + iter] = phi_v[middle_s_idx + iter - 1] + num/den * ( slist_interval[middle_s_idx + iter - 1] + slist_interval[middle_s_idx + iter] ) / 2; 

 s = slist[middle_s_idx - iter];
 num = sum( 1i * mu * exp(1i * s * extract[,1]) );
 den = sum( kappa * exp(1i * s * extract[,1]) );
 phi_v[middle_s_idx - iter] = phi_v[middle_s_idx - iter + 1] - num/den * ( slist_interval[middle_s_idx - iter + 1] + slist_interval[middle_s_idx - iter] ) / 2; 
}
phi_v = exp( phi_v );

phi_v_list = cbind(phi_v_list, phi_v);
#}
################ END t = min_age ##############################################

phi_muoverkappa = array(0,length(slist));
for(iter in 1:length(slist)){
 s = slist[iter];
 phi_muoverkappa[iter] = mean( exp(1i * mu / kappa * s) );
}
phi_nuuoverkappa = phi_muoverkappa / phi_v;

for(t in (min_age+1):(max_age-q-1)){
 curr_rho = t( rho_list[t-min_age+1,] );
 extract = extract_data(t,t+q+1,TRUE);
 kappa = sum(curr_rho) - 1;
 mu = extract[,1+q+1] - extract[,1];
 for(iter in 1:p){
  mu = mu - curr_rho[iter]*(extract[,1+q+1-iter] - extract[,1]);
 }
 phi_muoverkappa = array(0,length(slist));
 for(iter in 1:length(slist)){
  s = slist[iter];
  phi_muoverkappa[iter] = mean( exp(1i * mu / kappa * s) );
 }
 phi_v = phi_muoverkappa / phi_nuuoverkappa;
 
 phi_v_list = cbind(phi_v_list, phi_v);
}

age = min_age:(max_age-q-1);
#colnames(phi_v_list) <- age;

return( t( phi_v_list ) );
}

