################################################################################
# THIS FUNCTION ESTIMATES AR PARAMETER(S) RHO ALL TOGETHER - RETURNS "rho_list"
################################################################################
source("_extract_data.r");

stationary_est_rho_alltogether_parametric <- function(min_age,max_age){

totalN = 0;
numEdyy = 0;
numEdy = 0;
numEy = 0;
denEdyy = 0;
denEdy = 0;
denEy = 0;
for( t in (min_age+p+q):(max_age-1)){
 extract = extract_data(t-p-q,t+1,TRUE);
 N = dim(extract)[1];
 totalN = totalN + 1;
 numEdyy = numEdyy + sum( (extract[,4]-extract[,3])*extract[,1] );
 numEdy = numEdy + sum( extract[,4]-extract[,3] );
 numEy = numEy + sum( extract[,1] );
 denEdyy = denEdyy + sum( (extract[,3]-extract[,2])*extract[,1] );
 denEdy = denEdy + sum( extract[,3]-extract[,2] );
 denEy = denEy + sum( extract[,1] );
}
numEdyy = numEdyy / totalN;
numEdy = numEdy / totalN;
numEy = numEy / totalN;
denEdyy = denEdyy / totalN;
denEdy = denEdy / totalN;
denEy = denEy / totalN;
rho = (numEdyy - numEdy*numEy) / (denEdyy - denEdy*denEy);

age = (min_age):max_age;
rho_list = array(rho,dim=c(1,length(age)));
colnames(rho_list) <- age;

return ( t( rho_list ) );
}