source("_est_Ev1.r");
source("_est_Ev2.r");
source("_est_Ev3.r");
source("_est_Ev4.r");

horizon = 50;
delta_t_list = 1:(horizon-t);

lim=c(-1,1)
IRF_var_U = matrix(0,t-min_age,101);
ulist = -50:50/50 * 1.0;
plot(ulist, 0*ulist, type="l", lty=1, xlim=lim, ylim=lim, xlab=paste("Transotory Earnings at Age ", t), ylab="Expected Future Transitory Earnings")
initial_Central_u2 = 0;
Central_u2 = 0;
for( delta_iter in 0:length(delta_t_list) ){

 if( delta_iter == 0 ){
  delta_t = 0;
 }
 if( delta_iter > 0 ){
  delta_t = delta_t_list[ delta_iter ];  ### Years After
 }
 curr_rho = t( rho_list[t+delta_t-min_age+1,] );
 extract = extract_data(t+delta_t,t+delta_t+q+1,TRUE);

 Ev1 <- est_Ev1(min_age,max_age,p,q,curr_rho,extract);
 phiv1 <- Ev1 * (1i);
 Ev2 <- est_Ev2(min_age,max_age,p,q,curr_rho,extract);
 phiv2 <- Ev2 * (-1);
 Ey1 <- mean(extract[,1]);
 phiy1 <- Ey1 * (1i);
 Ey2 <- mean(extract[,1]^2);
 phiy2 <- Ey2 * (-1);

 phiu1 = phiy1 - phiv1;
 Eu1 = Re( phiu1 / (1i) );
 phiu2 = phiy2 - 2*phiy1*phiv1 - phiv2 + 2*phiv1^2;
 Eu2 = Re( phiu2 / (-1) );

 if( delta_iter == 0 ){
  initial_Central_u2 = Eu2 - Eu1^2;
 }
 if( delta_iter > 0 ){
  Central_u2 = Eu2 - Eu1^2;
 }

 par(new=TRUE)
 plot(ulist, ulist * 0 + Central_u2 - initial_Central_u2, type="l", lty=delta_iter+1, xlim=lim, ylim=lim, xlab="", ylab="")
 IRF_var_U = rbind( IRF_var_U, matrix( Central_u2 - initial_Central_u2, 1, length(ulist)) )
}
legend(min(lim),max(lim),lty=1:length(delta_t_list)+1,paste("Age ",delta_t_list+t))

IRF_var_U = (IRF_var_U < 0) * 0 + (IRF_var_U >= 0) * IRF_var_U

IRF_var_U_monotone = IRF_var_U;
for( it in 2:(dim(IRF_var_U)[1]) ){
 IRF_var_U_monotone[it,] = (IRF_var_U_monotone[it-1,] <= IRF_var_U_monotone[it,]) * IRF_var_U_monotone[it,] + (IRF_var_U_monotone[it-1,] > IRF_var_U_monotone[it,]) * IRF_var_U_monotone[it-1,]
}

IRF_var_U_smooth = IRF_var_U;
for( it in 2:(dim(IRF_var_U)[1]-1) ){
 IRF_var_U_smooth[it,] = colMeans(IRF_var_U_monotone[(it-1):(it+1),])
}
IRF_var_U_smooth[dim(IRF_var_U)[1],]=IRF_var_U_smooth[dim(IRF_var_U)[1]-1,]

plot(IRF_var_U_smooth[,1])