t = 30;        ### Baseline Age
delta_t = 20;  ### Years After

################################################################################
# FIRST ESTIMATE THE MARGINALS OF BASELINE U AND LONG-RUN SUM OF ETAS
################################################################################
phi_sumeta = array(0,length(slist_coarse));
for(iter in 1:length(slist_coarse)){
 phi_sumeta[iter] = phi_u_list_coarse[(t-min_age+1+delta_t),iter] / phi_u_list_coarse[(t-min_age+1),iter];
}

ulist = -500:500/500 * 2.5;
fulist = ulist * 0;
h = choose_h_normal_reference(ulist,phi_u_list_coarse[t-min_age+1,],slist_coarse,var_u_list[t-min_age+1]);
for( iter in 1:length(ulist) ){
 fulist[iter] = fourier(ulist[iter],phi_u_list_coarse[t-min_age+1,],slist_coarse,h,TRUE);
}

fu2list = ulist * 0;
h = choose_h_normal_reference(ulist,phi_u_list_coarse[t-min_age+1+delta_t,],slist_coarse,var_u_list[t-min_age+1+delta_t]);
for( iter in 1:length(ulist) ){
 fu2list[iter] = fourier(ulist[iter],phi_u_list_coarse[t-min_age+1+delta_t,],slist_coarse,h,TRUE);
}

sumetalist = (-1*length(ulist)):length(ulist) * (ulist[2]-ulist[1])
fsumetalist = sumetalist * 0;
h = choose_h_normal_reference(sumetalist,phi_sumeta,slist_coarse,NULL);
for( iter in 1:length(sumetalist) ){
 fsumetalist[iter] = fourier(sumetalist[iter],phi_sumeta,slist_coarse,h,TRUE);
}

################################################################################
# SECOND, ESTIMATE THE LONG-RUN JOINT OF U
################################################################################
fuu_longrun = array(0,dim=c(length(ulist),length(ulist)));
for(iter in 1:length(ulist)){
 for(jter in 1:length(ulist)){
  eta2 = ulist[jter] - ulist[iter];
  eta2idx = order(abs(sumetalist - eta2))[1];
  fuu_longrun[iter,jter] = fulist[iter] * fsumetalist[eta2idx];
 }
}
fuu_longrun = (Re(fuu_longrun) > 0) * fuu_longrun + (Re(fuu_longrun) <= 0) * fuu_longrun * 0;
fuu_longrun = fuu_longrun / sum( fuu_longrun*(ulist[2]-ulist[1])^2 );

################################################################################
# COMPUTE THE OPULA ON THE DIAGONAL
################################################################################
qlist = 1:199 / 200;
copula_list = qlist;
lower_tdc_list = qlist;
upper_tdc_list = qlist;
Fulist = fulist;
Fu2list = fu2list;
for(iter in 1:length(ulist)){
 Fulist[iter] = sum(fulist[1:iter]) / sum(fulist);
 Fu2list[iter] = sum(fu2list[1:iter]) / sum(fu2list);
}

for(idx in 1:length(qlist)){
 q = qlist[idx];
 u_idx = order( (Fulist - q)^2 )[1];
 u2_idx = order( (Fu2list - q)^2 )[1];
 copula_list[idx] = sum(fuu_longrun[1:u_idx,1:u2_idx]) / sum(fuu_longrun);
 lower_tdc_list[idx] = max( 0, copula_list[idx] / q );
 #upper_tdc_list[idx] = max( 0, (1 - 2*q + copula_list[idx]) / (1 - q) );
 upper_tdc_list[idx] = max( 0, sum(fuu_longrun[u_idx:length(ulist),u2_idx:length(ulist)]) / sum(fuu_longrun) / (1-q) );
}



################################################################################
# NORMAL NEXT
################################################################################
fuu_longrun_normal = get_bivariate_normal(ulist,fuu_longrun);

################################################################################
# COMPUTE THE OPULA ON THE DIAGONAL
################################################################################
copula_list_normal = qlist;
lower_tdc_list_normal = qlist;
upper_tdc_list_normal = qlist;

for(idx in 1:length(qlist)){
 q = qlist[idx];
 u_idx = order( (Fulist - q)^2 )[1];
 u2_idx = order( (Fu2list - q)^2 )[1];
 copula_list_normal[idx] = sum(fuu_longrun_normal[1:u_idx,1:u2_idx]) / sum(fuu_longrun_normal);
 lower_tdc_list_normal[idx] = max( 0, copula_list_normal[idx] / q );
 #upper_tdc_list_normal[idx] = max( 0, (1 - 2*q + copula_list_normal[idx]) / (1 - q) );
 upper_tdc_list_normal[idx] = max( 0, sum(fuu_longrun_normal[u_idx:length(ulist),u2_idx:length(ulist)]) / sum(fuu_longrun_normal) / (1-q) );
}

################################################################################
# DISPLAY THE OPULA ON THE DIAGONAL
################################################################################
plot(qlist,lower_tdc_list,type="l",xlim=c(0,1),ylim=c(0,1),xlab="q",ylab="Lower Tail Dependence Function L(q)");
par(new=TRUE)
plot(qlist,lower_tdc_list_normal,type="l",lty=3,xlim=c(0,1),ylim=c(0,1),xlab="",ylab="");
abline(v=0);
abline(v=1);
abline(h=0);
abline(h=1);

plot(qlist,upper_tdc_list,type="l",xlim=c(0,1),ylim=c(0,1),xlab="q",ylab="Upper Tail Dependence Function U(q)");
par(new=TRUE)
plot(qlist,upper_tdc_list_normal,type="l",lty=3,xlim=c(0,1),ylim=c(0,1),xlab="",ylab="");
abline(v=0);
abline(v=1);
abline(h=0);
abline(h=1);