################################################################################
# ESTIMATE PHI_V, PHI_U, AND PHI_ETA WITH COARSE RESOLUTION OF S
################################################################################
coarseness = 1.0;
max_exp = 100 / coarseness;
slist_coarse = c(-1*1.05^(-3.3*coarseness*((-1*max_exp):0)), 0, 1.05^(3.3*coarseness*(0:max_exp))) * 0.0001;
phi_v_list_coarse <- est_phi_v(min_age,max_age,p,q,slist_coarse,rho_list);
phi_u_list_coarse <- est_phi_u(min_age,max_age,slist_coarse,phi_v_list_coarse);
phi_eta_list_coarse <- est_phi_eta(min_age,max_age,slist_coarse,phi_u_list_coarse);

age_list = min_age:(max_age-q-1-3);
ulist_coarse = -25:25/25 * 1.0;
vlist_coarse = -15:15/25 * 1.0;
fuulist = array(0,dim=c(length(age_list),length(ulist_coarse),length(ulist_coarse)));
fvvlist = array(0,dim=c(length(age_list),length(vlist_coarse),length(vlist_coarse)));
for(iter in 1:length(age_list)){
 t = age_list[iter];
 fuulist[iter,,] <- est_fuu(t,phi_u_list_coarse,phi_eta_list_coarse,slist_coarse,ulist_coarse,min_age,var_u_list,TRUE,TRUE);
 fvvlist[iter,,] <- est_fvv(t,fuulist[iter,,],phi_v_list_coarse,slist_coarse,ulist_coarse,vlist_coarse,min_age,TRUE,TRUE)
}

################################################################################
# ESTIMATE PHI_V, PHI_U, AND PHI_ETA WITH VERY COARSE RESOLUTION OF S
################################################################################
coarseness = 5.0;
max_exp = 100 / coarseness;
slist_verycoarse = c(-1*1.05^(-3.3*coarseness*((-1*max_exp):0)), 0, 1.05^(3.3*coarseness*(0:max_exp))) * 0.0001;
phi_v_list_verycoarse <- est_phi_v(min_age,max_age,p,q,slist_verycoarse,rho_list);
phi_u_list_verycoarse <- est_phi_u(min_age,max_age,slist_verycoarse,phi_v_list_verycoarse);
phi_eta_list_verycoarse <- est_phi_eta(min_age,max_age,slist_verycoarse,phi_u_list_verycoarse);

age_list = min_age:(max_age-q-1-3);
ulist_verycoarse = -20:20/20 * 1.0;
vlist_verycoarse = -12:12/20 * 1.0;
fuuulist = array(0,dim=c(length(age_list),length(ulist_verycoarse),length(ulist_verycoarse),length(ulist_verycoarse)));
fvvvlist = array(0,dim=c(length(age_list),length(vlist_verycoarse),length(vlist_verycoarse),length(vlist_verycoarse)));
for(iter in 1:length(age_list)){
 t = age_list[iter];
 # THE NEXT LINE INTENTIONALLY USES COARSE RESOLUTION #
 fuuulist[iter,,,] <- est_fuuu(t,phi_u_list_coarse,phi_eta_list_coarse,slist_coarse,ulist_verycoarse,min_age,var_u_list,TRUE,TRUE);
 # THE NEXT LINE USES VERY COARSE RESOLUTION #
 fvvvlist[iter,,,] <- est_fvvv(t,fuuulist[iter,,,],phi_v_list_verycoarse,slist_verycoarse,ulist_verycoarse,vlist_verycoarse,min_age,TRUE,TRUE);
}
