t = 30;        ### Baseline Age
delta_t = 20;  ### Years After

################################################################################
# FIRST ESTIMATE THE MARGINALS OF BASELINE U AND LONG-RUN SUM OF ETAS
################################################################################
phi_sumeta = array(0,length(slist_coarse));
for(iter in 1:length(slist_coarse)){
 phi_sumeta[iter] = phi_u_list_coarse[(t-min_age+1+delta_t),iter] / phi_u_list_coarse[(t-min_age+1),iter];
}

ulist = -50:50/50 * 1.0;
fulist = ulist * 0;
h = choose_h_normal_reference(ulist,phi_u_list_coarse[t-min_age+1,],slist_coarse,var_u_list[t-min_age+1]);
for( iter in 1:length(ulist) ){
 fulist[iter] = fourier(ulist[iter],phi_u_list_coarse[t-min_age+1,],slist_coarse,h,TRUE);
}

sumetalist = (-1*length(ulist)):length(ulist) * (ulist[2]-ulist[1])
fsumetalist = sumetalist * 0;
h = choose_h_normal_reference(sumetalist,phi_sumeta,slist_coarse,NULL);
for( iter in 1:length(sumetalist) ){
 fsumetalist[iter] = fourier(sumetalist[iter],phi_sumeta,slist_coarse,h,TRUE);
}

################################################################################
# SECOND, ESTIMATE THE LONG-RUN JOINT OF U
################################################################################
fuu_longrun = array(0,dim=c(length(ulist),length(ulist)));
for(iter in 1:length(ulist)){
 for(jter in 1:length(ulist)){
  eta2 = ulist[jter] - ulist[iter];
  eta2idx = order(abs(sumetalist - eta2))[1];
  fuu_longrun[iter,jter] = fulist[iter] * fsumetalist[eta2idx];
 }
}
fuu_longrun = (Re(fuu_longrun) > 0) * fuu_longrun + (Re(fuu_longrun) <= 0) * fuu_longrun * 0;
fuu_longrun = fuu_longrun / sum( fuu_longrun*(ulist[2]-ulist[1])^2 );

################################################################################
# THIRD, ESTIMATE THE LONG-RUN JOINT OF V
################################################################################
extract = extract_data(t,t+delta_t,TRUE);

uu = array(ulist,dim=c(length(ulist),length(ulist)));

phi_vv_list = array(0,dim=c(length(slist_coarse),length(slist_coarse)));
for(iter in 1:length(slist_coarse)){
 for(jter in 1:length(slist_coarse)){
  s1 = slist_coarse[iter];
  s2 = slist_coarse[jter];
  num = mean( exp(1i*s1*extract[,1] + 1i*s2*extract[,1+delta_t]) );
  den = sum( exp(1i*s1*uu + 1i*s2*t(uu)) * fuu_longrun * (ulist[2]-ulist[1])^2 );
  phi_vv_list[iter,jter] = num / den;
 }
}

middle_s_idx = (length(slist_coarse)+1)/2;
temp_slist_interval = slist_coarse[2:length(slist_coarse)] - slist_coarse[1:(length(slist_coarse)-1)];
slist_interval = c(temp_slist_interval[1:(middle_s_idx-1)], temp_slist_interval[middle_s_idx], temp_slist_interval[middle_s_idx:length(temp_slist_interval)]);
s1mat = array(slist_coarse,dim=c(length(slist_coarse),length(slist_coarse)));
s2mat = t(array(slist_coarse,dim=c(length(slist_coarse),length(slist_coarse))));

vlist = -50:50/50 * 0.75;
hlist = 1:25/100;
min_h = 0;
min_ise = 999999;
var_v = get_variance(phi_v_list_coarse[t-min_age+1,],slist_coarse)
for(hter in 1:length(hlist)){
 h = hlist[hter];
 fv = array(0,length(vlist));
 for(iter in 1:length(vlist)){
  v1 = vlist[iter];
  v2 = 0;
  fv[iter] = sum( exp(-1i*s1mat*v1 -1i*s2mat*v2) * phi_vv_list * ker( h*s1mat ) * ker( h*s2mat ) * (slist_interval%*%t(slist_interval)) ) * 1/2^2/3.14159^2;
  fv[iter] = Re(fv[iter]);
 }
 ise = sum( ( Re(fv) - dnorm(vlist,0,var_v^.5) )^2 );
 if( ise < min_ise ){
  min_ise = ise;
  min_h = h;
 }
}

h = min_h
fvv_longrun = array(0,dim=c(length(vlist),length(vlist)));
for(iter in 1:length(vlist)){
 for(jter in 1:length(vlist)){
  v1 = vlist[iter];
  v2 = vlist[jter];
  fvv_longrun[iter,jter] = sum( exp(-1i*s1mat*v1 -1i*s2mat*v2) * phi_vv_list * ker( h*s1mat ) * ker( h*s2mat ) * (slist_interval%*%t(slist_interval)) ) * 1/2^2/3.14159^2;
  fvv_longrun[iter,jter] = Re(fvv_longrun[iter,jter]);
 }
}
fvv_longrun = (Re(fvv_longrun) > 0) * fvv_longrun + (Re(fvv_longrun) <= 0) * 0;
fvv_longrun = fvv_longrun / sum( Re(fvv_longrun)*(vlist[2]-vlist[1])^2 );

################################################################################
# DISPLAY RESULTS
################################################################################
library(mvtnorm);
level_vector = 1:30*0.1;

# U NONPARAMETRIC #
contour(ulist,ulist,fuu_longrun,levels=level_vector,xlab=expression(U[t]),ylab=expression(U[t+Delta][t]),xlim=c(-1,1),ylim=c(-1,1));
abline(coef=c(0,1),lty=3);
# Add Regression Line #
par(new=TRUE);
plot(ulist,get_bivariate_normal_conditional_expectation(ulist,fuu_longrun),type="l",col="gray",xlab="",ylab="",xlim=c(-1,1),ylim=c(-1,1));
#### U NORMAL #####
contour(ulist,ulist,get_bivariate_normal(ulist,fuu_longrun),levels=level_vector,xlab=expression(U[t]),ylab=expression(U[t+Delta][t]),xlim=c(-1,1),ylim=c(-1,1));
abline(coef=c(0,1),lty=3);

# V NONPARAMETRIC #
contour(vlist,vlist,fvv_longrun,levels=level_vector,xlab=expression(V[t]),ylab=expression(V[t+Delta][t]),xlim=c(-.75,.75),ylim=c(-.75,.75));
abline(coef=c(0,1),lty=3);
# Add Regression Line #
par(new=TRUE);
plot(vlist,get_bivariate_normal_conditional_expectation(vlist,fvv_longrun),type="l",col="gray",xlab="",ylab="",xlim=c(-.75,.75),ylim=c(-.75,.75));
#### V NORMAL #####
contour(vlist,vlist,get_bivariate_normal(vlist,fvv_longrun),levels=level_vector,xlab=expression(V[t]),ylab=expression(V[t+Delta][t]),xlim=c(-.75,.75),ylim=c(-.75,.75));
abline(coef=c(0,1),lty=3);
