NODATA = -999999;
BOTTOM = 0.00+0.00;
TOP = 1.00-0.00;

################################################################################
# TRIM THE TOP AND BOTTOM OF Y FOR EACH AGE-YEAR CELL 
################################################################################

### Read Data ##################################################################
#data <- read.csv("data_r.csv",header=FALSE);
data <- read.csv("data_noage_r.csv",header=FALSE);
data_id <- data[,1];    ### Individual ID
data_t <- data[,2];     ### Age
data_year <- data[,3];  ### Year
data_Y <- data[,4];     ### Residual
N = dim(data)[1];

min_t = min(data_t);
max_t = max(data_t);
min_year = min(data_year);
max_year = max(data_year);

################################################################################
# ASSIGN "NODATA" TO OUTLIERS
################################################################################
for(iter in min_t:max_t){
 for(jter in min_year:max_year){
  temp_Y = data_Y*(data_t==iter & data_year==jter) + log(-1 + 2*(data_t==iter & data_year==jter));
  bottom = quantile(temp_Y, BOTTOM, na.rm=TRUE);
  top = quantile(temp_Y, TOP, na.rm=TRUE);
  trim = 1*(data_Y < bottom | data_Y > top);
  data_Y = data_Y*(data_t!=iter | data_year!=jter | !trim) + NODATA*(data_t==iter & data_year==jter & trim);
 }
}

################################################################################
# REMOVE ENTRIES WITH "NODATA"
################################################################################
new_data_id = NULL;
new_data_t = NULL;
new_data_year = NULL;
new_data_Y = NULL;
for(iter in 1:N){
 if( data_Y[iter] != NODATA ){
  new_data_id = rbind(new_data_id, data_id[iter]);
  new_data_t = rbind(new_data_t, data_t[iter]);
  new_data_year = rbind(new_data_year, data_year[iter]);
  new_data_Y = rbind(new_data_Y, data_Y[iter]);
 }
}

################################################################################
# NEXT PART DEMEANS FOR EACH AGE-YEAR CELL
################################################################################
#for(iter in min_t:max_t){
# for(jter in min_year:max_year){
#  mean = sum(new_data_Y*(new_data_t==iter | new_data_year==jter)) / sum(1*(new_data_t==iter | new_data_year==jter));
#  new_data_Y = new_data_Y*(new_data_t!=iter | new_data_year!=jter) + (new_data_Y-mean)*(new_data_t==iter & new_data_year==jter);
# }
#}

new_data = cbind(new_data_id,new_data_t,new_data_year,new_data_Y);
write.table(new_data, file="data_trim_r.csv",row.names=FALSE,col.names=FALSE,sep=",");
