################################################################################
# THIS FUNCTION CHOOSES BANDWIDTH BY MINIMIZING THE VARIANCE GAP
################################################################################
source("_get_mean.r");
source("_get_variance.r");
source("_fourier.r");
hlist = 1:80/600;

choose_h_variance_match <- function( xlist,phi,slist ){

mean = get_mean(phi,slist);
var = get_variance(phi,slist);
normlist = dnorm(xlist, mean, var^0.5);
min_gap = 999999;
min_h = NA;

for( h in hlist ){
 flist = xlist * 0;
 for( iter in 1:length(xlist) ){
  flist[iter] = fourier(xlist[iter],phi,slist,h,TRUE);
 }

 estmean = sum( xlist * flist );
 estvar = sum( ( xlist - estmean )^2 * flist );
 if( abs(estvar - var) < min_gap ){
  min_gap = abs(estvar - var);
  min_h = h;
 }
}

return( min_h );
}