################################################################################
# THIS FUNCTION ESTIMATES F(V,V,V) JOINT DENSITY OF V_T, V_{T+1} AND V_{T+2}
################################################################################
source("_est_fuuu.r");

est_fvvv <- function(t,fuuu,phi_v_list,slist,ulist,vlist,min_age,nonnegative=FALSE,graph=FALSE){

extract = extract_data(t,t+2,TRUE);

uuu1 = array(0,dim=c(length(ulist),length(ulist),length(ulist)));
uuu2 = array(0,dim=c(length(ulist),length(ulist),length(ulist)));
uuu3 = array(0,dim=c(length(ulist),length(ulist),length(ulist)));
for(iter in 1:length(ulist)){
 uuu1[iter,,] = ulist[iter];
 uuu2[,iter,] = ulist[iter];
 uuu3[,,iter] = ulist[iter];
}
#fuuu <- est_fuuu(t,phi_u_list,phi_eta_list,slist,ulist,min_age,FALSE);

phi_vvv_list = array(0,dim=c(length(slist),length(slist),length(slist)));
for(iter in 1:length(slist)){
 for(jter in 1:length(slist)){
  for(kter in 1:length(slist)){
   s1 = slist[iter];
   s2 = slist[jter];
   s3 = slist[kter];
   num = mean( exp(1i*s1*extract[,1] + 1i*s2*extract[,2] + 1i*s3*extract[,3]) );
   den = sum( exp(1i*s1*uuu1 + 1i*s2*uuu2 + 1i*s3*uuu3) * fuuu * (ulist[2]-ulist[1])^3 );
   phi_vvv_list[iter,jter,kter] = num / den;
  }
 }
}

middle_s_idx = (length(slist)+1)/2;
temp_slist_interval = slist[2:length(slist)] - slist[1:(length(slist)-1)];
slist_interval = c(temp_slist_interval[1:(middle_s_idx-1)], temp_slist_interval[middle_s_idx], temp_slist_interval[middle_s_idx:length(temp_slist_interval)]);
slist_interval_mat = array(0,dim=c(length(slist_interval),length(slist_interval),length(slist_interval)));
for(iter in 1:length(slist_interval)){
 for(jter in 1:length(slist_interval)){
  for(kter in 1:length(slist_interval)){
   slist_interval_mat[iter,jter,kter] = slist_interval[iter] * slist_interval[jter] * slist_interval[kter];
  }
 }
}
s1mat = array(0,dim=c(length(slist),length(slist),length(slist)));
s2mat = array(0,dim=c(length(slist),length(slist),length(slist)));
s3mat = array(0,dim=c(length(slist),length(slist),length(slist)));
for(iter in 1:length(slist)){
 s1mat [iter,,] = slist[iter];
 s2mat [,iter,] = slist[iter];
 s3mat [,,iter] = slist[iter];
}

hlist = 5:25/100;
min_h = 0;
min_ise = 999999;
var_v = get_variance(phi_v_list[t-min_age+1,],slist)
for(hter in 1:length(hlist)){
 h = hlist[hter];
 fv = array(0,length(vlist));
 for(iter in 1:length(vlist)){
  v1 = vlist[iter];
  v2 = 0;
  v3 = 0;
  fv[iter] = sum( exp(-1i*s1mat*v1 -1i*s2mat*v2 -1i*s3mat*v3) * phi_vvv_list * ker( h*s1mat ) * ker( h*s2mat ) * ker( h*s3mat ) * slist_interval_mat * 1/2^3/3.14159^3 );
  fv[iter] = Re(fv[iter]);
 }
 ise = sum( ( Re(fv) - dnorm(vlist,0,var_v^.5) )^2 );
 if( ise < min_ise ){
  min_ise = ise;
  min_h = h;
 }
}

h = min_h
fvvv = array(0,dim=c(length(vlist),length(vlist),length(vlist)));
for(iter in 1:length(vlist)){
 for(jter in 1:length(vlist)){
  for(kter in 1:length(vlist)){
   v1 = vlist[iter];
   v2 = vlist[jter];
   v3 = vlist[kter];
   fvvv[iter,jter,kter] = sum( exp(-1i*s1mat*v1 -1i*s2mat*v2 -1i*s3mat*v3) * phi_vvv_list * ker( h*s1mat ) * ker( h*s2mat ) * ker( h*s3mat ) * slist_interval_mat ) * 1/2^3/3.14159^3;
   fvvv[iter,jter,kter] = Re(fvvv[iter,jter,kter]);
  }
 }
}

if(nonnegative){
 fvvv = (Re(fvvv) > 0) * Re(fvvv) + (Re(fvvv) <= 0) * 0;
 fvvv = Re(fvvv) / sum( Re(fvvv)*(vlist[2]-vlist[1])^3 );
}

fvvv = Re(fvvv) / sum( Re(fvvv) * (vlist[2]-vlist[1])^3 );

if(graph){
 fvv = array(0,dim=c(length(vlist),length(vlist)));
 for(iter in 1:length(vlist)){
  for(kter in 1:length(vlist)){
   fvv[iter,kter] = sum(fvvv[iter,,kter] * (vlist[2]-vlist[1]));
  }
 }
 contour(vlist,vlist,Re(fvv),xlab=expression(V[t]),ylab=expression(V[t+2]));
 abline(coef=c(0,1),lty=3);
}

return( Re(fvvv) );
}
