################################################################################
# THIS FUNCTION ESTIMATES PHI_EPSILON - RETURNS "phi_epsilon_list"
# ROWS = AGES, COLS = S
################################################################################

est_phi_epsilon <- function(fvvlist,vlist_coarse,fvvvlist,vlist_verycoarse,slist_coarse,rho_list,lambda_list){

vmat31 = array(0,dim=c(length(vlist_verycoarse),length(vlist_verycoarse),length(vlist_verycoarse)));
vmat32 = array(0,dim=c(length(vlist_verycoarse),length(vlist_verycoarse),length(vlist_verycoarse)));
vmat33 = array(0,dim=c(length(vlist_verycoarse),length(vlist_verycoarse),length(vlist_verycoarse)));
for(iter in 1:length(vlist_verycoarse)){
 for(jter in 1:length(vlist_verycoarse)){
  for(kter in 1:length(vlist_verycoarse)){
   vmat31[iter,,] = vlist_verycoarse[iter];
   vmat32[,jter,] = vlist_verycoarse[jter];
   vmat33[,,kter] = vlist_verycoarse[kter];
  }
 }
}

vmat21 = array(0,dim=c(length(vlist_coarse),length(vlist_coarse)));
vmat22 = array(0,dim=c(length(vlist_coarse),length(vlist_coarse)));
for(iter in 1:length(vlist_coarse)){
 for(jter in 1:length(vlist_coarse)){
  vmat21[iter,] = vlist_coarse[iter];
  vmat22[,jter] = vlist_coarse[jter];
 }
}

middle_s_idx = (length(slist_coarse)+1)/2;
temp_slist_interval = slist_coarse[2:length(slist_coarse)] - slist_coarse[1:(length(slist_coarse)-1)];
slist_interval = c(temp_slist_interval[1:(middle_s_idx-1)], temp_slist_interval[middle_s_idx], temp_slist_interval[middle_s_idx:length(temp_slist_interval)]);

phi_epsilon_list = array(NA,length(slist_coarse));
for( t in (min_age+1):(max_age-q-1-3) ){
 rho0 = rho_list[t-min_age+1];
 rho1 = rho_list[t-min_age+1+1];
 lambda1 = lambda_list[t-min_age+1+1];

 phi_epsilon = array(0,length(slist_coarse));

 for(iter in 1:((length(slist_coarse)-1)/2)){
  s = slist_coarse[middle_s_idx + iter];
  num = 1i * sum( (vmat33-rho1*vmat32)/lambda1 * exp(1i*s*(vmat32-rho0*vmat31)) * fvvvlist[t-min_age+1-1,,,] * (vlist_verycoarse[2]-vlist_verycoarse[1])^3);
  den = sum( exp( vmat22 - rho0 * vmat21 ) * fvvlist[t-min_age+1-1,,] * (vlist_coarse[2]-vlist_coarse[1])^2 );
  phi_epsilon[middle_s_idx + iter] = phi_epsilon[middle_s_idx + iter - 1] + num/den * ( slist_interval[middle_s_idx + iter - 1] + slist_interval[middle_s_idx + iter] ) / 2; 

  s = slist_coarse[middle_s_idx - iter];
  num = 1i * sum( (vmat33-rho1*vmat32)/lambda1 * exp(1i*s*(vmat32-rho0*vmat31)) * fvvvlist[t-min_age+1-1,,,] * (vlist_verycoarse[2]-vlist_verycoarse[1])^3);
  den = sum( exp( vmat22 - rho0 * vmat21 ) * fvvlist[t-min_age+1-1,,] * (vlist_coarse[2]-vlist_coarse[1])^2 );
  phi_epsilon[middle_s_idx - iter] = phi_epsilon[middle_s_idx - iter + 1] - num/den * ( slist_interval[middle_s_idx - iter + 1] + slist_interval[middle_s_idx - iter] ) / 2; 
 }
 phi_epsilon = exp( phi_epsilon );

 phi_epsilon_list = rbind(phi_epsilon_list, phi_epsilon);
}

return ( phi_epsilon_list );
}