################################################################################
# THIS FUNCTION RETURNS FOURIER TRANSFORM OF A GIVEN CHARACTERISTIC FUNCTION
################################################################################

#### FOR THE KERNEL BELOW, SEE BISSANTZ, DUMBEN, HOLZMANN AND MUNK PAGE 492 ####
b = 0.1#1.0 #0.1;
c = 0.1#0.01#0.1;
ker <- function(u){
 1*(abs(u) < c) + exp((-1*b*exp(-1*b/(abs(u)-c)^2))/(abs(u)-1)^2)*(c < abs(u))*(abs(u) < 1);
}

fourier <- function(x,phi,slist,h,nonnegative=TRUE){
 middle_s_idx = (length(slist)+1)/2;
 temp_slist_interval = slist[2:length(slist)] - slist[1:(length(slist)-1)];
 slist_interval = c(temp_slist_interval[1:(middle_s_idx-1)], temp_slist_interval[middle_s_idx], temp_slist_interval[middle_s_idx:length(temp_slist_interval)]);

 fx = (1/2/3.14159) * sum( exp( -1i * slist * x ) * phi * ker( h * slist ) * slist_interval );
 fx = Re(fx)
 if( nonnegative ){
  fx = fx * (fx >= 0) + 0 * (fx < 0);
 }
 return( fx );
}