library(mvtnorm);

get_bivariate_normal <- function(xlist,fxx){

xlist_interval = xlist[2]-xlist[1];
xmat1 = array(xlist,dim=c(length(xlist),length(xlist)));
xmat2 = t(xmat1);

mean1 = sum( xmat1 * fxx * xlist_interval^2);
mean2 = sum( xmat2 * fxx * xlist_interval^2);
var1 = sum( xmat1^2 * fxx * xlist_interval^2) - mean1^2;
var2 = sum( xmat2^2 * fxx * xlist_interval^2) - mean2^2;
cov = sum( xmat1 * xmat2 * fxx * xlist_interval^2) - mean1 * mean2;

mean = c(mean1,mean2);
sigma = array(c(var1,cov,cov,var2),dim=c(2,2));

normfxx = fxx * 0;

for(iter in 1:length(xlist)){
 for(jter in 1:length(xlist)){
  normfxx[iter,jter] = dmvnorm(c(xlist[iter],xlist[jter]),mean,sigma);
 }
}

return( normfxx );
}