source("_est_Ev1.r");
source("_est_Ev2.r");
source("_est_Ev3.r");
source("_est_Ev4.r");

get_var_list <- function(min_age,max_age,p,q,rho_list){

var_u_list = NULL;
var_v_list = NULL;
var_eta_list = NULL;
prev_phiu1 = 0;
prev_phiu2 = 0;
for(t in min_age:(max_age-q-1)){

 curr_rho = t( rho_list[t-min_age+1,] );
 extract = extract_data(t,t+q+1,TRUE);
 ################################################################################
 # ESTIMATE MOMENTS OF U AND V
 ################################################################################
 Ev1 <- est_Ev1(min_age,max_age,p,q,curr_rho,extract);
 phiv1 <- Ev1 * (1i);
 Ev2 <- est_Ev2(min_age,max_age,p,q,curr_rho,extract);
 phiv2 <- Ev2 * (-1);
 Ey1 <- mean(extract[,1]);
 phiy1 <- Ey1 * (1i);
 Ey2 <- mean(extract[,1]^2);
 phiy2 <- Ey2 * (-1);

 phiu1 = phiy1 - phiv1;
 Eu1 = Re( phiu1 / (1i) );
 phiu2 = phiy2 - 2*phiy1*phiv1 - phiv2 + 2*phiv1^2;
 Eu2 = Re( phiu2 / (-1) );

 phieta1 = phiu1 - prev_phiu1;
 Eeta1 = Re( phieta1 / (1i) );
 phieta2 = phiu2 - 2*phiu1*prev_phiu1 - prev_phiu2 + 2*prev_phiu1^2;
 Eeta2 = Re( phieta2 / (-1) );

 prev_phiu1 = phiu1;
 prev_phiu2 = phiu2;
 ################################################################################
 # ESTIMATE INDICES OF U AND V
 ################################################################################
 Central_u2 = Eu2 - Eu1^2;
 Central_v2 = Ev2 - Ev1^2;
 Central_eta2 = Eeta2 - Eeta1^2;

 var_u_list = rbind(var_u_list, Central_u2);
 var_v_list = rbind(var_v_list, Central_v2);
 var_eta_list = rbind(var_eta_list, Central_eta2);
}

var_list <- abs( cbind(var_u_list,var_v_list,var_eta_list) );
age = min_age:(max_age-q-1);
rownames(var_list) <- age;

return( var_list );
}
