t = 30;        ### Baseline Age

IRF_lower_tdc_list = NULL;
IRF_upper_tdc_list = NULL;
IRF_lower_tdc_list_normal = NULL;
IRF_upper_tdc_list_normal = NULL;

for(delta_t in 1:20){

#delta_t = 20;  ### Years After

################################################################################
# FIRST ESTIMATE THE MARGINALS OF BASELINE U AND LONG-RUN SUM OF ETAS
################################################################################
phi_sumeta = array(0,length(slist_coarse));
for(iter in 1:length(slist_coarse)){
 phi_sumeta[iter] = phi_u_list_coarse[(t-min_age+1+delta_t),iter] / phi_u_list_coarse[(t-min_age+1),iter];
}

ulist = -500:500/500 * 2.5;
fulist = ulist * 0;
h = choose_h_normal_reference(ulist,phi_u_list_coarse[t-min_age+1,],slist_coarse,var_u_list[t-min_age+1]);
for( iter in 1:length(ulist) ){
 fulist[iter] = fourier(ulist[iter],phi_u_list_coarse[t-min_age+1,],slist_coarse,h,TRUE);
}

fu2list = ulist * 0;
h = choose_h_normal_reference(ulist,phi_u_list_coarse[t-min_age+1+delta_t,],slist_coarse,var_u_list[t-min_age+1+delta_t]);
for( iter in 1:length(ulist) ){
 fu2list[iter] = fourier(ulist[iter],phi_u_list_coarse[t-min_age+1+delta_t,],slist_coarse,h,TRUE);
}

sumetalist = (-1*length(ulist)):length(ulist) * (ulist[2]-ulist[1])
fsumetalist = sumetalist * 0;
h = choose_h_normal_reference(sumetalist,phi_sumeta,slist_coarse,NULL);
for( iter in 1:length(sumetalist) ){
 fsumetalist[iter] = fourier(sumetalist[iter],phi_sumeta,slist_coarse,h,TRUE);
}

################################################################################
# SECOND, ESTIMATE THE LONG-RUN JOINT OF U
################################################################################
fuu_longrun = array(0,dim=c(length(ulist),length(ulist)));
for(iter in 1:length(ulist)){
 for(jter in 1:length(ulist)){
  eta2 = ulist[jter] - ulist[iter];
  eta2idx = order(abs(sumetalist - eta2))[1];
  fuu_longrun[iter,jter] = fulist[iter] * fsumetalist[eta2idx];
 }
}
fuu_longrun = (Re(fuu_longrun) > 0) * fuu_longrun + (Re(fuu_longrun) <= 0) * fuu_longrun * 0;
fuu_longrun = fuu_longrun / sum( fuu_longrun*(ulist[2]-ulist[1])^2 );

################################################################################
# THIRD, ESTIMATE THE LONG-RUN JOINT OF V
################################################################################
extract = extract_data(t,t+delta_t,TRUE);

uu = array(ulist,dim=c(length(ulist),length(ulist)));

phi_vv_list = array(0,dim=c(length(slist_coarse),length(slist_coarse)));
for(iter in 1:length(slist_coarse)){
 for(jter in 1:length(slist_coarse)){
  s1 = slist_coarse[iter];
  s2 = slist_coarse[jter];
  num = mean( exp(1i*s1*extract[,1] + 1i*s2*extract[,1+delta_t]) );
  den = sum( exp(1i*s1*uu + 1i*s2*t(uu)) * fuu_longrun * (ulist[2]-ulist[1])^2 );
  phi_vv_list[iter,jter] = num / den;
 }
}

middle_s_idx = (length(slist_coarse)+1)/2;
temp_slist_interval = slist_coarse[2:length(slist_coarse)] - slist_coarse[1:(length(slist_coarse)-1)];
slist_interval = c(temp_slist_interval[1:(middle_s_idx-1)], temp_slist_interval[middle_s_idx], temp_slist_interval[middle_s_idx:length(temp_slist_interval)]);
s1mat = array(slist_coarse,dim=c(length(slist_coarse),length(slist_coarse)));
s2mat = t(array(slist_coarse,dim=c(length(slist_coarse),length(slist_coarse))));

vlist = -50:50/50 * 0.75;
hlist = 1:25/100;
min_h = 0;
min_ise = 999999;
var_v = get_variance(phi_v_list_coarse[t-min_age+1,],slist_coarse)
for(hter in 1:length(hlist)){
 h = hlist[hter];
 fv = array(0,length(vlist));
 for(iter in 1:length(vlist)){
  v1 = vlist[iter];
  v2 = 0;
  fv[iter] = sum( exp(-1i*s1mat*v1 -1i*s2mat*v2) * phi_vv_list * ker( h*s1mat ) * ker( h*s2mat ) * (slist_interval%*%t(slist_interval)) ) * 1/2^2/3.14159^2;
  fv[iter] = Re(fv[iter]);
 }
 ise = sum( ( Re(fv) - dnorm(vlist,0,var_v^.5) )^2 );
 if( ise < min_ise ){
  min_ise = ise;
  min_h = h;
 }
}

h = min_h
fvv_longrun = array(0,dim=c(length(vlist),length(vlist)));
for(iter in 1:length(vlist)){
 for(jter in 1:length(vlist)){
  v1 = vlist[iter];
  v2 = vlist[jter];
  fvv_longrun[iter,jter] = sum( exp(-1i*s1mat*v1 -1i*s2mat*v2) * phi_vv_list * ker( h*s1mat ) * ker( h*s2mat ) * (slist_interval%*%t(slist_interval)) ) * 1/2^2/3.14159^2;
  fvv_longrun[iter,jter] = Re(fvv_longrun[iter,jter]);
 }
}
fvv_longrun = (Re(fvv_longrun) > 0) * Re(fvv_longrun) + (Re(fvv_longrun) <= 0) * 0;
fvv_longrun = Re(fvv_longrun) / sum( Re(fvv_longrun)*(vlist[2]-vlist[1])^2 );

################################################################################
# COMPUTE THE OPULA ON THE DIAGONAL
################################################################################
qlist = 1:199 / 200;
copula_list = qlist;
lower_tdc_list = qlist;
upper_tdc_list = qlist;

fvlist = vlist * 0;
h = choose_h_normal_reference(vlist,phi_v_list_coarse[t-min_age+1,],slist_coarse,var_v_list[t-min_age+1]);
for( iter in 1:length(vlist) ){
 fvlist[iter] = fourier(vlist[iter],phi_v_list_coarse[t-min_age+1,],slist_coarse,h,TRUE);
}

fv2list = vlist * 0;
h = choose_h_normal_reference(vlist,phi_v_list_coarse[t-min_age+1+delta_t,],slist_coarse,var_v_list[t-min_age+1+delta_t]);
for( iter in 1:length(ulist) ){
 fv2list[iter] = fourier(vlist[iter],phi_v_list_coarse[t-min_age+1+delta_t,],slist_coarse,h,TRUE);
}

Fvlist = fvlist;
Fv2list = fv2list;
for(iter in 1:length(ulist)){
 Fvlist[iter] = sum(fvlist[1:iter]) / sum(fvlist);
 Fv2list[iter] = sum(fv2list[1:iter]) / sum(fv2list);
}

for(idx in 1:length(qlist)){
 q = qlist[idx];
 v_idx = order( (Fvlist - q)^2 )[1];
 v2_idx = order( (Fv2list - q)^2 )[1];
 copula_list[idx] = sum(fvv_longrun[1:v_idx,1:v2_idx]) / sum(fvv_longrun);
 lower_tdc_list[idx] = max( 0, copula_list[idx] / q );
 upper_tdc_list[idx] = max( 0, sum(fvv_longrun[v_idx:length(vlist),v2_idx:length(vlist)]) / sum(fvv_longrun) / (1-q) );
}
IRF_lower_tdc_list = rbind(IRF_lower_tdc_list, matrix(lower_tdc_list, 1, length(lower_tdc_list)));
IRF_upper_tdc_list = rbind(IRF_upper_tdc_list, matrix(upper_tdc_list, 1, length(upper_tdc_list)));

################################################################################
# NORMAL NEXT
################################################################################
fvv_longrun_normal = get_bivariate_normal(vlist,fvv_longrun);

################################################################################
# COMPUTE THE OPULA ON THE DIAGONAL
################################################################################
copula_list_normal = qlist;
lower_tdc_list_normal = qlist;
upper_tdc_list_normal = qlist;

for(idx in 1:length(qlist)){
 q = qlist[idx];
 v_idx = order( (Fvlist - q)^2 )[1];
 v2_idx = order( (Fv2list - q)^2 )[1];
 copula_list_normal[idx] = sum(fvv_longrun_normal[1:v_idx,1:v2_idx]) / sum(fvv_longrun_normal);
 lower_tdc_list_normal[idx] = max( 0, copula_list_normal[idx] / q );
 upper_tdc_list_normal[idx] = max( 0, sum(fvv_longrun_normal[v_idx:length(vlist),v2_idx:length(vlist)]) / sum(fvv_longrun_normal) / (1-q) );
}
IRF_lower_tdc_list_normal = rbind(IRF_lower_tdc_list_normal, matrix(lower_tdc_list_normal, 1, length(lower_tdc_list_normal)));
IRF_upper_tdc_list_normal = rbind(IRF_upper_tdc_list_normal, matrix(upper_tdc_list_normal, 1, length(upper_tdc_list_normal)));

plot(qlist,lower_tdc_list,type="l",xlim=c(0,1),ylim=c(0,1),xlab="q",ylab="Lower Tail Dependence Function L(q)");
par(new=TRUE)
plot(qlist,lower_tdc_list_normal,type="l",lty=3,xlim=c(0,1),ylim=c(0,1),xlab="",ylab="");
abline(v=0);
abline(v=1);
abline(h=0);
abline(h=1);
Sys.sleep(0.1)
print(delta_t)
flush.console() 
}#end for#

IRF_upper_tdc_list = rbind(1,IRF_upper_tdc_list)
IRF_upper_tdc_list = rbind(matrix(NA,t-25,dim(IRF_upper_tdc_list)[2]),IRF_upper_tdc_list)
IRF_upper_tdc_list[,198]

IRF_upper_tdc_list_normal = rbind(1,IRF_upper_tdc_list_normal)
IRF_upper_tdc_list_normal = rbind(matrix(NA,t-25,dim(IRF_upper_tdc_list_normal)[2]),IRF_upper_tdc_list_normal)
IRF_upper_tdc_list_normal[,198]

IRF_lower_tdc_list = rbind(1,IRF_lower_tdc_list)
IRF_lower_tdc_list = rbind(matrix(NA,t-25,dim(IRF_lower_tdc_list)[2]),IRF_lower_tdc_list)
IRF_lower_tdc_list[,2]

IRF_lower_tdc_list_normal = rbind(1,IRF_lower_tdc_list_normal)
IRF_lower_tdc_list_normal = rbind(matrix(NA,t-25,dim(IRF_lower_tdc_list_normal)[2]),IRF_lower_tdc_list_normal)
IRF_lower_tdc_list_normal[,2]

################################################################################
# DISPLAY RESULTS
################################################################################
q_value=0.01
q_index = order(abs(qlist-q_value))[1]
IRF_age_list = 25:50;
plot(IRF_age_list,IRF_lower_tdc_list[,q_index],type="l",lty=1,lwd=2,ylim=c(0,1),xlab="Age t",ylab="Lower Tail Dependence")
par(new=TRUE)
plot(IRF_age_list,IRF_lower_tdc_list_normal[,q_index],type="l",lty=2,lwd=2,ylim=c(0,1),xlab="",ylab="")
abline(h=0)
abline(h=1)