source("_est_Ev1.r");
source("_est_Ev2.r");
source("_est_Ev3.r");
source("_est_Ev4.r");

NUM_BOOT = 10000;
t = 30;

curr_rho = t( rho_list[t-min_age+1,] );
extract = extract_data(t,t+q+1,TRUE);
################################################################################
# ESTIMATE MOMENTS OF U AND V
################################################################################
Ev1 <- est_Ev1(min_age,max_age,p,q,curr_rho,extract);
phiv1 <- Ev1 * (1i);
Ev2 <- est_Ev2(min_age,max_age,p,q,curr_rho,extract);
phiv2 <- Ev2 * (-1);
Ev3 <- est_Ev3(min_age,max_age,p,q,curr_rho,extract);
phiv3 <- Ev3 * (-1i);
Ev4 <- est_Ev4(min_age,max_age,p,q,curr_rho,extract);
phiv4 <- Ev4 * 1;
Ey1 <- mean(extract[,1]);
phiy1 <- Ey1 * (1i);
Ey2 <- mean(extract[,1]^2);
phiy2 <- Ey2 * (-1);
Ey3 <- mean(extract[,1]^3);
phiy3 <- Ey3 * (-1i);
Ey4 <- mean(extract[,1]^4);
phiy4 <- Ey4 * 1;

phiu1 = phiy1 - phiv1;
Eu1 = Re( phiu1 / (1i) );
phiu2 = phiy2 - 2*phiy1*phiv1 - phiv2 + 2*phiv1^2;
Eu2 = Re( phiu2 / (-1) );
phiu3 = phiy3 - 3*phiy2*phiv1 - 3*phiy1*phiv2 + 6*phiy1*phiv1^2 - phiv3 + 6*phiv1*phiv2 - 6*phiv1^3;
Eu3 = Re( phiu3 / (-1i) );
phiu4 = phiy4 - 4*phiy3*phiv1 - 6*phiy2*phiv2 + 12*phiy2*phiv1^2 - 4*phiy1*phiv3 + 24*phiy1*phiv1*phiv2 - 24*phiy1*phiv1*phiv2 - phiv4 + 8*phiv1*phiv3 + 6*phiv2^2 - 36*phiv1^2*phiv2 + 24*phiv1^4;
Eu4 = Re( phiu4 / 1 );

################################################################################
# ESTIMATE INDICES OF U AND V
################################################################################
Central_u2 = Eu2 - Eu1^2;
Central_u3 = Eu3 - 3*Eu1*Eu2 + 2*Eu1^3;
Central_u4 = Eu4 - 3*Eu1*Eu3 + 6*Eu1^2*Eu2 - 3*Eu1^4;
Sd_u = Central_u2^0.5;
Skewness_u = Central_u3 / Central_u2^1.5;
Kurtosis_u = Central_u4 / Central_u2^2;
estimates_indices_u = cbind(Eu1,Sd_u,Skewness_u,Kurtosis_u);

Central_v2 = Ev2 - Ev1^2;
Central_v3 = Ev3 - 3*Ev1*Ev2 + 2*Ev1^3;
Central_v4 = Ev4 - 3*Ev1*Ev3 + 6*Ev1^2*Ev2 - 3*Ev1^4;
Sd_v = Central_v2^0.5;
Skewness_v = Central_v3 / Central_v2^1.5;
Kurtosis_v = Central_v4 / Central_v2^2;
estimates_indices_v = cbind(Ev1,Sd_v,Skewness_v,Kurtosis_v);

################################################################################
# START BOOTSTRAP
################################################################################
N = dim(extract)[1];

list_estimates_indices_u = NULL;
list_estimates_indices_v = NULL;
for(iter in 1:NUM_BOOT){
 boot_idx = ceiling( runif(N)*N );
 boot_extract = extract[boot_idx,];

 Ev1 <- est_Ev1(min_age,max_age,p,q,curr_rho,boot_extract);
 phiv1 <- Ev1 * (1i);
 Ev2 <- est_Ev2(min_age,max_age,p,q,curr_rho,boot_extract);
 phiv2 <- Ev2 * (-1);
 Ev3 <- est_Ev3(min_age,max_age,p,q,curr_rho,boot_extract);
 phiv3 <- Ev3 * (-1i);
 Ev4 <- est_Ev4(min_age,max_age,p,q,curr_rho,boot_extract);
 phiv4 <- Ev4 * 1;
 Ey1 <- mean(boot_extract[,1]);
 phiy1 <- Ey1 * (1i);
 Ey2 <- mean(boot_extract[,1]^2);
 phiy2 <- Ey2 * (-1);
 Ey3 <- mean(boot_extract[,1]^3);
 phiy3 <- Ey3 * (-1i);
 Ey4 <- mean(boot_extract[,1]^4);
 phiy4 <- Ey4 * 1;
 
 phiu1 = phiy1 - phiv1;
 Eu1 = Re( phiu1 / (1i) );
 phiu2 = phiy2 - 2*phiy1*phiv1 - phiv2 + 2*phiv1^2;
 Eu2 = Re( phiu2 / (-1) );
 phiu3 = phiy3 - 3*phiy2*phiv1 - 3*phiy1*phiv2 + 6*phiy1*phiv1^2 - phiv3 + 6*phiv1*phiv2 - 6*phiv1^3;
 Eu3 = Re( phiu3 / (-1i) );
 phiu4 = phiy4 - 4*phiy3*phiv1 - 6*phiy2*phiv2 + 12*phiy2*phiv1^2 - 4*phiy1*phiv3 + 24*phiy1*phiv1*phiv2 - 24*phiy1*phiv1*phiv2 - phiv4 + 8*phiv1*phiv3 + 6*phiv2^2 - 36*phiv1^2*phiv2 + 24*phiv1^4;
 Eu4 = Re( phiu4 / 1 );

 Central_u2 = Eu2 - Eu1^2;
 Central_u3 = Eu3 - 3*Eu1*Eu2 + 2*Eu1^3;
 Central_u4 = Eu4 - 3*Eu1*Eu3 + 6*Eu1^2*Eu2 - 3*Eu1^4;
 Sd_u = Central_u2^0.5;
 Skewness_u = Central_u3 / Central_u2^1.5;
 Kurtosis_u = Central_u4 / Central_u2^2;
 boot_estimates_indices_u = cbind(Eu1,Sd_u,Skewness_u,Kurtosis_u);

 Central_v2 = abs( Ev2 - Ev1^2 );
 Central_v3 = Ev3 - 3*Ev1*Ev2 + 2*Ev1^3;
 Central_v4 = Ev4 - 3*Ev1*Ev3 + 6*Ev1^2*Ev2 - 3*Ev1^4;
 Sd_v = Central_v2^0.5;
 Skewness_v = Central_v3 / Central_v2^1.5;
 Kurtosis_v = Central_v4 / Central_v2^2;
 boot_estimates_indices_v = cbind(Ev1,Sd_v,Skewness_v,Kurtosis_v);

 list_estimates_indices_u = rbind(list_estimates_indices_u,boot_estimates_indices_u);
 list_estimates_indices_v = rbind(list_estimates_indices_v,boot_estimates_indices_v);
}

se_estimates_indices_u = ( colMeans(list_estimates_indices_u^2) - colMeans(list_estimates_indices_u)^2 )^.5;
se_estimates_indices_v = ( colMeans(list_estimates_indices_v^2) - colMeans(list_estimates_indices_v)^2 )^.5;

p_kurtosis_u_3 = 1 - pnorm( (estimates_indices_u[4] - 3)/se_estimates_indices_u[4] )
p_kurtosis_v_3 = 1 - pnorm( (estimates_indices_v[4] - 3)/se_estimates_indices_v[4] )
####################################################
# [,1] Mean, [,2] SD, [,3] SKEWNESS, [,4] KURTOSIS #
####################################################
options(digits=10)
estimates_indices_u;
se_estimates_indices_u;
p_kurtosis_u_3
estimates_indices_v;
se_estimates_indices_v;
p_kurtosis_v_3